<?php
/**
 * @file
 * Contains Attribute for miniOrange SAML IDP Module.
 */

 /**
 * Showing Settings form.
 */
namespace Drupal\miniorange_saml_idp\Form;
use Symfony\Component\HttpFoundation\RedirectResponse;
use Drupal\Core\Form\FormBase;
use Drupal\Core\Form\FormStateInterface;

 class Mapping extends FormBase {
	 
  public function getFormId() {
    return 'miniorange_saml_mapping';
  }

	 
 public function buildForm(array $form, \Drupal\Core\Form\FormStateInterface $form_state) {

  if (\Drupal::config('miniorange_saml_idp.settings')->get('miniorange_saml_customer_admin_email') == NULL || \Drupal::config('miniorange_saml_idp.settings')->get('miniorange_saml_customer_id') == NULL
    || \Drupal::config('miniorange_saml_idp.settings')->get('miniorange_saml_customer_admin_token') == NULL || \Drupal::config('miniorange_saml_idp.settings')->get('miniorange_saml_customer_api_key') == NULL) {
    $form['header'] = array(
      '#markup' => '<center><h3>You need to register with miniOrange before using this module.</h3></center>',
    );

    return $form;
  }
  
  global $base_url;
 
  $form['markup_idp_attr_header'] = array(
    '#markup' =>
        '<h3>Attribute Mapping (Optional)</h3>',
  );
  
  $form['miniorange_saml_idp_nameid_attr_map'] = array(
    '#type' => 'select',
	'#title' => t('NameID Attribute:'),
	'#options' => array(
	  'emailAddress' => t('Drupal Email Address'),
	  'username' => t('Drupal Username'),
	),
	'#default_value' =>\Drupal::config('miniorange_saml_idp.settings')->get('miniorange_saml_idp_nameid_attr_map'),
	'#description' => t('(<b>NOTE:</b> This attribute value is sent in SAML Response. Users in your Service Provider<br />'
	. ' will be searched (existing users) or created (new users) based on this attribute.<br />'
	. ' Use <b>EmailAddress</b> by default.)'),
  );
  





     $form['markup_idp_attr_header2'] = array(
         '#markup' => '<br/><br/><h3>Custom Attribute Mapping <a href="' . $base_url . '/admin/config/people/miniorange_saml_idp/licensing">[Premium]</a></h3>'
     );

     $form['miniorange_saml_idp_attr1_name'] = array(
         '#type' => 'textfield',
         '#title' => t('Attribute Name 1'),
         '#default_value' => \Drupal::config('miniorange_saml_idp.settings')->get('miniorange_saml_idp_attr1_name'),

         '#attributes' => array('placeholder' => 'Enter Attribute Name'),
         '#required' => FALSE,
         '#disabled' => TRUE,
     );


     $form['miniorange_saml_idp_attr1_value'] = array(
         '#type' => 'select',
         '#title' => t('Attribute Value'),
         '#disabled' => TRUE,
         '#options' => array(
             '' => t('Select Attribute Value'),
             'mail' => t('Email Address'),
             'name' => t('Username'),
             'roles' => t('User Roles'),
         ),

         '#default_value' =>\Drupal::config('miniorange_saml_idp.settings')->get('miniorange_saml_idp_attr1_value'),
     );

     $form['miniorange_saml_idp_attr2_name'] = array(
         '#type' => 'textfield',
         '#title' => t('Attribute Name 2'),
         '#default_value' =>\Drupal::config('miniorange_saml_idp.settings')->get('miniorange_saml_idp_attr2_name'),

         '#attributes' => array('placeholder' => 'Enter Attribute Name'),
         '#required' => FALSE,
         '#disabled' => TRUE,
     );

     $form['miniorange_saml_idp_attr2_value'] = array(
         '#type' => 'select',
         '#title' => t('Attribute Value'),
         '#disabled' => TRUE,
         '#options' => array(
             '' => t('Select Attribute Value'),
             'mail' => t('Email Address'),
             'name' => t('Username'),

             'roles' => t('User Roles'),
         ),

         '#default_value' =>\Drupal::config('miniorange_saml_idp.settings')->get('miniorange_saml_idp_attr2_value'),
     );

     $form['miniorange_saml_idp_attr3_name'] = array(
         '#type' => 'textfield',
         '#title' => t('Attribute Name 3'),
         '#default_value' => \Drupal::config('miniorange_saml_idp.settings')->get('miniorange_saml_idp_attr3_name'),

         '#attributes' => array('placeholder' => 'Enter Attribute Name'),
         '#required' => FALSE,
         '#disabled' => TRUE,
     );

     $form['miniorange_saml_idp_attr3_value'] = array(
         '#type' => 'select',
         '#title' => t('Attribute Value'),
         '#disabled' => TRUE,
         '#options' => array(
             '' => t('Select Attribute Value'),
             'mail' => t('Email Address'),
             'name' => t('Username'),

             'roles' => t('User Roles'),
         ),

         '#default_value' =>  \Drupal::config('miniorange_saml_idp.settings')->get('miniorange_saml_idp_attr3_value'),

     );

     $form['miniorange_saml_idp_attr_map_submit'] = array(
         '#type' => 'submit',
         '#value' => t('Save'),

     );
  
  return $form;

 }
 
  public function submitForm(array &$form, \Drupal\Core\Form\FormStateInterface $form_state) {
  


global $base_url;
  
 $mo_admin_email =\Drupal::config('miniorange_saml_idp.settings')->get('miniorange_saml_customer_admin_email');
  
  if(!isset($mo_admin_email)){
    drupal_set_message(t('Please register with miniOrange to enable Drupal as IDP.'));
	
  $test=  $base_url . '/admin/config/people/miniorange_saml_idp/Mapping';
  $response = new RedirectResponse($test);
    $response->send();
  }
  
  $nameid_attr = $form['miniorange_saml_idp_nameid_attr_map']['#value'];
  if($nameid_attr == ''){
    $nameid_attr = 'emailAddress';
  }

  \Drupal::configFactory()->getEditable('miniorange_saml_idp.settings')->set('miniorange_saml_idp_nameid_attr_map', $nameid_attr)->save();
  drupal_set_message(t('Your settings are saved successfully.'));
 

  }
  }